(*****************************************************************************
 * 
 * This file is part of Tonyc. 
 *
 * Tonyc is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
******************************************************************************)
(* Polymorphic hash consing,
   you don't need to understand what this is all about... *)

type 'a hash_consed

val hash_value : 'a hash_consed -> 'a
val hash_tag : 'a hash_consed -> int

module type Comp =
  sig
    type t
    val equal : t -> t -> bool
    val hash : t -> int
  end

module type S =
  sig
    type t
    val f : unit -> t -> t hash_consed
  end

module Make (X : Comp) : (S with type t = X.t)

val init : unit -> unit
val register_hcons : (unit -> 'a -> 'a hash_consed) ->
                     (unit -> 'a -> 'a hash_consed)
