(*****************************************************************************
 * 
 * This file is part of Tonyc. 
 *
 * Tonyc is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
******************************************************************************)
type typ = TYPE_none        (* no type (should not be used)       *)
         | TYPE_proc        (* proc (return type)                 *)
         | TYPE_int         (* int                                *)
         | TYPE_byte        (* byte                               *)
         | TYPE_array of    (* array                              *)
             typ *          (*   element type                     *)
             int            (*   size of array, if known, or zero *)
         | TYPE_char        (* char                               *)
         | TYPE_bool        (* boolean                            *)
         | TYPE_list of     (* list                               *)
             typ *          (*   element type                     *)
             int            (*   current number of elements       *)

val sizeOfType : typ -> int
val equalType : typ -> typ -> bool
val string_of_type : typ -> string
